#include <iostream>
using namespace std;

const int Maksimalno = 300000;

long long dan_kupovine[Maksimalno];
long long koliko_kutija[Maksimalno];
long long zbir_pakovanja[Maksimalno]; 


int main() {

    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int Kada_je_kupio, do_kad_jede;
    cin >> Kada_je_kupio >> do_kad_jede;

    for (int i = 0; i < Kada_je_kupio; i++) {


        cin >> dan_kupovine[i] >> koliko_kutija[i];

        
        if (i == 0) {


            zbir_pakovanja[i] = koliko_kutija[i];


        }

        else {


            zbir_pakovanja[i] = zbir_pakovanja[i - 1] + koliko_kutija[i];


        }


    }

    int pokazivac = 0;


    while (do_kad_jede--) {

        long long koji_Dan;
        cin >> koji_Dan;

        
        long long ukupno_pojela = 0;

        
        while (pokazivac < Kada_je_kupio && dan_kupovine[pokazivac] <= koji_Dan) {

            ukupno_pojela = zbir_pakovanja[pokazivac];

            pokazivac++;

        }

        
        cout << ukupno_pojela << endl;


    }








    return 0;
}